Index: trunk/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90
===================================================================
--- trunk/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90	(revision 2528)
@@ -4,4 +4,6 @@
    !!              Initialisation of diagnostics ice variables
    !!======================================================================
+   !! History :  2.0  ! 2004-01 (C. Ethe, G. Madec)  Original code
+   !!----------------------------------------------------------------------
 #if defined key_lim3
    !!----------------------------------------------------------------------
@@ -11,48 +13,40 @@
    !!   lim_istate_init :  initialization of ice state and namelist read
    !!----------------------------------------------------------------------
-   !! * Modules used
-   USE phycst
-   USE oce             ! dynamics and tracers variables
-   USE dom_oce
-   USE sbc_oce         ! Surface boundary condition: ocean fields
-   USE par_ice         ! ice parameters
-   USE eosbn2          ! equation of state
-   USE in_out_manager
-   USE dom_ice
-   USE ice
-   USE lbclnk
+   USE phycst           ! physical constant
+   USE oce              ! dynamics and tracers variables
+   USE dom_oce          ! ocean domain
+   USE sbc_oce          ! Surface boundary condition: ocean fields
+   USE eosbn2           ! equation of state
+   USE ice              ! sea-ice variables
+   USE par_ice          ! ice parameters
+   USE dom_ice          ! sea-ice domain
+   USE in_out_manager   ! I/O manager
+   USE lbclnk           ! lateral boundary condition - MPP exchanges
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Accessibility
-   PUBLIC lim_istate      ! routine called by lim_init.F90
-
-   !! * Module variables
-   REAL(wp) ::             & !!! ** init namelist (namiceini) **
-      ttest    = 2.0  ,    &  ! threshold water temperature for initial sea ice
-      hninn    = 0.5  ,    &  ! initial snow thickness in the north
-      hginn_u  = 2.5  ,    &  ! initial ice thickness in the north
-      aginn_u  = 0.7  ,    &  ! initial leads area in the north
-      hginn_d  = 5.0  ,    &  ! initial ice thickness in the north
-      aginn_d  = 0.25 ,    &  ! initial leads area in the north
-      hnins    = 0.1  ,    &  ! initial snow thickness in the south
-      hgins_u  = 1.0  ,    &  ! initial ice thickness in the south
-      agins_u  = 0.7  ,    &  ! initial leads area in the south
-      hgins_d  = 2.0  ,    &  ! initial ice thickness in the south
-      agins_d  = 0.2  ,    &  ! initial leads area in the south
-      sinn     = 6.301 ,   &  ! initial salinity 
-      sins     = 6.301
-
-   REAL(wp)  ::            &  ! constant values
-      zzero   = 0.0     ,  &
-      zone    = 1.0
-
-   !!----------------------------------------------------------------------
-   !!   LIM 3.0,  UCL-LOCEAN-IPSL (2008)
+   PUBLIC   lim_istate      ! routine called by lim_init.F90
+
+   !                                  !!** init namelist (namiceini) **
+   REAL(wp) ::   ttest    = 2.0_wp     ! threshold water temperature for initial sea ice
+   REAL(wp) ::   hninn    = 0.5_wp     ! initial snow thickness in the north
+   REAL(wp) ::   hginn_u  = 2.5_wp     ! initial ice thickness in the north
+   REAL(wp) ::   aginn_u  = 0.7_wp     ! initial leads area in the north
+   REAL(wp) ::   hginn_d  = 5.0_wp     ! initial ice thickness in the north
+   REAL(wp) ::   aginn_d  = 0.25_wp    ! initial leads area in the north
+   REAL(wp) ::   hnins    = 0.1_wp     ! initial snow thickness in the south
+   REAL(wp) ::   hgins_u  = 1.0_wp     ! initial ice thickness in the south
+   REAL(wp) ::   agins_u  = 0.7_wp     ! initial leads area in the south
+   REAL(wp) ::   hgins_d  = 2.0_wp     ! initial ice thickness in the south
+   REAL(wp) ::   agins_d  = 0.2_wp     ! initial leads area in the south
+   REAL(wp) ::   sinn     = 6.301_wp   ! initial salinity 
+   REAL(wp) ::   sins     = 6.301_wp   !
+
+   !!----------------------------------------------------------------------
+   !! NEMO/LIM3 3.3 , UCL - NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -65,21 +59,11 @@
       !! ** Method  :   restart from a state defined in a binary file
       !!                or from arbitrary sea-ice conditions
-      !!
-      !! History :
-      !!   2.0  !  01-04  (C. Ethe, G. Madec)  Original code
-      !!--------------------------------------------------------------------
-
-      !! * Local variables
+      !!-------------------------------------------------------------------
       INTEGER  ::   ji, jj, jk, jl             ! dummy loop indices
-
-      REAL(wp) ::       &  ! temporary scalar
-         zeps6, zeps, ztmelts, &
-         epsi06
-      REAL(wp), DIMENSION(jpm) ::   &
-         zgfactorn, zhin, &
-         zgfactors, zhis
-      REAL(wp) ::  &
-         zvol, zare, zh, zh1, zh2, zh3, zan, zbn, zas, zbs 
-      REAL(wp), DIMENSION(jpi,jpj) ::   zidto    ! ice indicator
+      REAL(wp) ::   zeps6, zeps, ztmelts, epsi06   ! local scalars
+      REAL(wp) ::  zvol, zare, zh, zh1, zh2, zh3, zan, zbn, zas, zbs 
+      REAL(wp), DIMENSION(jpm)     ::   zgfactorn, zhin 
+      REAL(wp), DIMENSION(jpm)     ::   zgfactors, zhis
+      REAL(wp), DIMENSION(jpi,jpj) ::   zidto      ! ice indicator
       !--------------------------------------------------------------------
 
@@ -87,5 +71,5 @@
       ! 1) Preliminary things 
       !--------------------------------------------------------------------
-      epsi06 = 1.0e-6
+      epsi06 = 1.e-6_wp
 
       CALL lim_istate_init     !  reading the initials parameters of the ice
@@ -116,17 +100,17 @@
 
       ! constants for heat contents
-      zeps   = 1.0d-20
-      zeps6  = 1.0d-06
+      zeps   = 1.e-20_wp
+      zeps6  = 1.e-06_wp
 
       ! zgfactor for initial ice distribution
-      zgfactorn(:) = 0.0
-      zgfactors(:) = 0.0
+      zgfactorn(:) = 0._wp
+      zgfactors(:) = 0._wp
 
       ! first ice type
       DO jl = ice_cat_bounds(1,1), ice_cat_bounds(1,2)
-         zhin (1)     = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
-         zgfactorn(1) = zgfactorn(1) + exp(-(zhin(1)-hginn_u)*(zhin(1)-hginn_u)/2.0)
-         zhis (1)     = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
-         zgfactors(1) = zgfactors(1) + exp(-(zhis(1)-hgins_u)*(zhis(1)-hgins_u)/2.0)
+         zhin (1)     = ( hi_max(jl-1) + hi_max(jl) ) * 0.5_wp
+         zgfactorn(1) = zgfactorn(1) + exp(-(zhin(1)-hginn_u)*(zhin(1)-hginn_u) * 0.5_wp )
+         zhis (1)     = ( hi_max(jl-1) + hi_max(jl) ) * 0.5_wp
+         zgfactors(1) = zgfactors(1) + exp(-(zhis(1)-hgins_u)*(zhis(1)-hgins_u) * 0.5_wp )
       END DO ! jl
       zgfactorn(1) = aginn_u / zgfactorn(1)
@@ -135,12 +119,12 @@
       ! -------------
       ! new distribution, polynom of second order, conserving area and volume
-      zh1 = 0.0
-      zh2 = 0.0
-      zh3 = 0.0
+      zh1 = 0._wp
+      zh2 = 0._wp
+      zh3 = 0._wp
       DO jl = 1, jpl
-         zh = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
+         zh = ( hi_max(jl-1) + hi_max(jl) ) * 0.5_wp
          zh1 = zh1 + zh
-         zh2 = zh2 + zh*zh
-         zh3 = zh3 + zh*zh*zh
+         zh2 = zh2 + zh * zh
+         zh3 = zh3 + zh * zh * zh
       END DO
       IF(lwp) WRITE(numout,*) ' zh1 : ', zh1
@@ -148,7 +132,7 @@
       IF(lwp) WRITE(numout,*) ' zh3 : ', zh3
 
-      zvol = aginn_u*hginn_u
+      zvol = aginn_u * hginn_u
       zare = aginn_u
-      IF ( jpl .GE. 2 ) THEN
+      IF( jpl >= 2 ) THEN
          zbn = ( zvol*zh2 - zare*zh3 ) / ( zh2*zh2 - zh1*zh3)
          zan = ( zare - zbn*zh1 ) / zh2
@@ -160,7 +144,7 @@
       IF(lwp) WRITE(numout,*) ' zan : ', zan 
 
-      zvol = agins_u*hgins_u
+      zvol = agins_u * hgins_u
       zare = agins_u
-      IF ( jpl .GE. 2 ) THEN
+      IF( jpl >= 2 ) THEN
          zbs = ( zvol*zh2 - zare*zh3 ) / ( zh2*zh2 - zh1*zh3)
          zas = ( zare - zbs*zh1 ) / zh2
@@ -205,5 +189,5 @@
             !--- Northern hemisphere
             !----------------------------------------------------------------
-            IF( fcor(ji,jj) >= 0.e0 ) THEN    
+            IF( fcor(ji,jj) >= 0._wp ) THEN    
 
                !-----------------------
@@ -453,6 +437,6 @@
             ENDIF ! on fcor
 
-         ENDDO
-      ENDDO
+         END DO
+      END DO
 
       !--------------------------------------------------------------------
@@ -494,5 +478,4 @@
 
       DO jl = 1, jpl
-
          CALL lbc_lnk( a_i(:,:,jl)  , 'T', 1. )
          CALL lbc_lnk( v_i(:,:,jl)  , 'T', 1. )
@@ -500,5 +483,5 @@
          CALL lbc_lnk( smv_i(:,:,jl), 'T', 1. )
          CALL lbc_lnk( oa_i(:,:,jl) , 'T', 1. )
-
+         !
          CALL lbc_lnk( ht_i(:,:,jl) , 'T', 1. )
          CALL lbc_lnk( ht_s(:,:,jl) , 'T', 1. )
@@ -514,15 +497,15 @@
             CALL lbc_lnk(e_i(:,:,jk,jl), 'T', 1. )
          END DO
-
-         a_i (:,:,jl) = tms(:,:) * a_i(:,:,jl)
-
+         !
+         a_i(:,:,jl) = tms(:,:) * a_i(:,:,jl)
       END DO
 
       CALL lbc_lnk( at_i , 'T', 1. )
       at_i(:,:) = tms(:,:) * at_i(:,:)                       ! put 0 over land
-
+      !
       CALL lbc_lnk( fsbbq  , 'T', 1. )
-
+      !
    END SUBROUTINE lim_istate
+
 
    SUBROUTINE lim_istate_init
@@ -532,24 +515,17 @@
       !! ** Purpose : Definition of initial state of the ice 
       !!
-      !! ** Method : Read the namiceini namelist and check the parameter 
-      !!       values called at the first timestep (nit000)
+      !! ** Method :   Read the namiceini namelist and check the parameter 
+      !!             values called at the first timestep (nit000)
       !!
-      !! ** input : 
-      !!        Namelist namiceini
-      !!
-      !! history :
-      !!  8.5  ! 03-08 (C. Ethe) original code
+      !! ** input  :   namelist namiceini
       !!-----------------------------------------------------------------------------
-      NAMELIST/namiceini/ ttest, hninn, hginn_u, aginn_u, hginn_d, aginn_d, hnins, &
-         hgins_u, agins_u, hgins_d, agins_d, sinn, sins
+      NAMELIST/namiceini/ ttest, hninn, hginn_u, aginn_u, hginn_d, aginn_d, hnins,   &
+         &                hgins_u, agins_u, hgins_d, agins_d, sinn, sins
       !!-----------------------------------------------------------------------------
-
-      ! Define the initial parameters
-      ! -------------------------
-
-      ! Read Namelist namiceini 
-      REWIND ( numnam_ice )
+      !
+      REWIND ( numnam_ice )               ! Read Namelist namiceini 
       READ   ( numnam_ice , namiceini )
-      IF(lwp) THEN
+      !
+      IF(lwp) THEN                        ! control print
          WRITE(numout,*)
          WRITE(numout,*) 'lim_istate_init : ice parameters inititialisation '
@@ -569,5 +545,5 @@
          WRITE(numout,*) '   initial  ice salinity       in the south     sins       = ', sins
       ENDIF
-
+      !
    END SUBROUTINE lim_istate_init
 
Index: trunk/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90
===================================================================
--- trunk/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90	(revision 2528)
@@ -86,7 +86,7 @@
 
    !!----------------------------------------------------------------------
-   !!   LIM 3.0,  UCL-LOCEAN-IPSL (2008)
+   !! NEMO/LIM3 3.3 , UCL - NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90
===================================================================
--- trunk/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90	(revision 2528)
@@ -1,7 +1,3 @@
 MODULE limitd_th
-#if defined key_lim3
-   !!----------------------------------------------------------------------
-   !!   'key_lim3' :                                   LIM3 sea-ice model
-   !!----------------------------------------------------------------------
    !!======================================================================
    !!                       ***  MODULE limitd_th ***
@@ -9,7 +5,9 @@
    !!                   computation of changes in g(h)      
    !!======================================================================
-
+#if defined key_lim3
    !!----------------------------------------------------------------------
-   !! * Modules used
+   !!   'key_lim3' :                                   LIM3 sea-ice model
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
    USE dom_ice
    USE par_oce          ! ocean parameters
@@ -17,5 +15,4 @@
    USE phycst           ! physical constants (ocean directory) 
    USE thd_ice
-   USE in_out_manager
    USE ice
    USE par_ice
@@ -24,4 +21,5 @@
    USE limcons
    USE prtctl           ! Print control
+   USE in_out_manager
    USE lib_mpp 
 
@@ -29,5 +27,4 @@
    PRIVATE
 
-   !! * Routine accessibility
    PUBLIC lim_itd_th        ! called by ice_stp
    PUBLIC lim_itd_th_rem
@@ -36,5 +33,4 @@
    PUBLIC lim_itd_shiftice
 
-   !! * Module variables
    REAL(wp)  ::           &  ! constant values
       epsi20 = 1e-20   ,  &
@@ -44,7 +40,7 @@
 
    !!----------------------------------------------------------------------
-   !!   LIM 3.0,  UCL-LOCEAN-IPSL (2008)
+   !! NEMO/LIM3 3.3 , UCL - NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/LIM_SRC_3/limmsh.F90
===================================================================
--- trunk/NEMOGCM/NEMO/LIM_SRC_3/limmsh.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/LIM_SRC_3/limmsh.F90	(revision 2528)
@@ -24,7 +24,7 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM 3.2,  UCL-ASTR-LOCEAN-IPSL (2009) 
+   !! NEMO/LIM3 3.3 , UCL - NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90
===================================================================
--- trunk/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90	(revision 2528)
@@ -7,49 +7,49 @@
    !!            3.0  !  2008-03  (M. Vancoppenolle) LIM3
    !!             -   !  2008-11  (M. Vancoppenolle, S. Bouillon, Y. Aksenov) add surface tilt in ice rheolohy 
+   !!            3.3  !  2009-05  (G.Garric) addition of the lim2_evp cas
    !!----------------------------------------------------------------------
-#if defined key_lim3
+#if defined key_lim3 || (  defined key_lim2 && ! defined key_lim2_vp )
    !!----------------------------------------------------------------------
-   !!   'key_lim3'                                      LIM3 sea-ice model
+   !!   'key_lim3'               OR                     LIM-3 sea-ice model
+   !!   'key_lim2' AND NOT 'key_lim2_vp'             VP LIM-2 sea-ice model
    !!----------------------------------------------------------------------
    !!   lim_rhg   : computes ice velocities
    !!----------------------------------------------------------------------
-   !! * Modules used
-   USE phycst
-   USE par_oce
-   USE dom_oce
-   USE dom_ice
-   USE sbc_oce         ! Surface boundary condition: ocean fields
-   USE sbc_ice         ! Surface boundary condition: ice fields
-   USE ice
-   USE lbclnk
-   USE lib_mpp
-   USE in_out_manager  ! I/O manager
-   USE limitd_me
-   USE prtctl          ! Print control
-
+   USE phycst           ! Physical constant
+   USE par_oce          ! Ocean parameters
+   USE dom_oce          ! Ocean domain
+   USE sbc_oce          ! Surface boundary condition: ocean fields
+   USE sbc_ice          ! Surface boundary condition: ice fields
+   USE lbclnk           ! Lateral Boundary Condition / MPP link
+   USE lib_mpp          ! MPP library
+   USE in_out_manager   ! I/O manager
+   USE prtctl           ! Print control
+#if defined key_lim3
+   USE ice              ! LIM-3: ice variables
+   USE dom_ice          ! LIM-3: ice domain
+   USE limitd_me        ! LIM-3: 
+#else
+   USE ice_2            ! LIM2: ice variables
+   USE dom_ice_2        ! LIM2: ice domain
+#endif
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC lim_rhg  ! routine called by lim_dyn
-
+   PUBLIC   lim_rhg   ! routine called by lim_dyn (or lim_dyn_2)
+
+   REAL(wp) ::   rzero   = 0._wp   ! constant values
+   REAL(wp) ::   rone    = 1._wp   ! constant values
+      
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
-
-   !! * Module variables
-   REAL(wp)  ::           &  ! constant values
-      rzero   = 0.e0   ,  &
-      rone    = 1.e0
    !!----------------------------------------------------------------------
-   !!   LIM 3.0,  UCL-LOCEAN-IPSL (2008) 
+   !! NEMO/LIM3 3.3 , UCL - NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
    SUBROUTINE lim_rhg( k_j1, k_jpj )
-
       !!-------------------------------------------------------------------
       !!                 ***  SUBROUTINE lim_rhg  ***
@@ -98,34 +98,16 @@
       !!                 e.g. in the Canadian Archipelago
       !!
-      !! ** References : Hunke and Dukowicz, JPO97
-      !!                 Bouillon et al., 08, in prep (update this when
-      !!                 published)
-      !!                 Vancoppenolle et al., OM08
+      !! References : Hunke and Dukowicz, JPO97
+      !!              Bouillon et al., Ocean Modelling 2009
+      !!              Vancoppenolle et al., Ocean Modelling 2008
+      !!-------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   k_j1    ! southern j-index for ice computation
+      INTEGER, INTENT(in) ::   k_jpj   ! northern j-index for ice computation
       !!
-      !!-------------------------------------------------------------------
-      ! * Arguments
-      !
-      INTEGER, INTENT(in) :: &
-         k_j1 ,                      & !: southern j-index for ice computation
-         k_jpj                         !: northern j-index for ice computation
-
-      ! * Local variables
-      INTEGER ::   ji, jj              !: dummy loop indices
-
-      INTEGER  :: &
-         jter                          !: temporary integers
-
+      INTEGER ::   ji, jj   ! dummy loop indices
+      INTEGER ::   jter     ! local integers
       CHARACTER (len=50) ::   charout
-
-      REAL(wp) :: &
-         zt11, zt12, zt21, zt22,     & !: temporary scalars
-         ztagnx, ztagny,             & !: wind stress on U/V points                       
-         delta                         !
-
-      REAL(wp) :: &
-         za,                         & !:
-         zstms,                      & !: temporary scalar for ice strength
-         zsang,                      & !: temporary scalar for coriolis term
-         zmask                         !: mask for the computation of ice mass
+      REAL(wp) ::   zt11, zt12, zt21, zt22, ztagnx, ztagny, delta                         !
+      REAL(wp) ::   za, zstms, zsang, zmask   ! local scalars
 
       REAL(wp),DIMENSION(jpi,jpj) :: &
@@ -145,38 +127,44 @@
 
       REAL(wp) :: &
-         dtevp,                      & !: time step for subcycling
-         dtotel,                     & !:
-         ecc2,                       & !: square of yield ellipse eccenticity
-         z0,                         & !: temporary scalar
-         zr,                         & !: temporary scalar
-         zcca, zccb,                 & !: temporary scalars
-         zu_ice2,                    & !: 
-         zv_ice1,                    & !:
-         zddc, zdtc,                 & !: temporary array for delta on corners
-         zdst,                       & !: temporary array for delta on centre
-         zdsshx, zdsshy,             & !: term for the gradient of ocean surface
-         sigma1, sigma2                !: internal ice stress
+         dtevp,                      & ! time step for subcycling
+         dtotel,                     & !
+         ecc2,                       & ! square of yield ellipse eccenticity
+         z0,                         & ! temporary scalar
+         zr,                         & ! temporary scalar
+         zcca, zccb,                 & ! temporary scalars
+         zu_ice2,                    & ! 
+         zv_ice1,                    & !
+         zddc, zdtc,                 & ! temporary array for delta on corners
+         zdst,                       & ! temporary array for delta on centre
+         zdsshx, zdsshy,             & ! term for the gradient of ocean surface
+         sigma1, sigma2                ! internal ice stress
+
+      REAL(wp),DIMENSION(jpi,jpj) ::   zf1, zf2   ! arrays for internal stresses
 
       REAL(wp),DIMENSION(jpi,jpj) :: &
-         zf1, zf2                      !: arrays for internal stresses
-
-      REAL(wp),DIMENSION(jpi,jpj) :: &
-         zdd, zdt,                   & !: Divergence and tension at centre of grid cells
-         zds,                        & !: Shear on northeast corner of grid cells
-         deltat,                     & !: Delta at centre of grid cells
-         deltac,                     & !: Delta on corners
-         zs1, zs2,                   & !: Diagonal stress tensor components zs1 and zs2 
-         zs12                          !: Non-diagonal stress tensor component zs12
+         zdd, zdt,                   & ! Divergence and tension at centre of grid cells
+         zds,                        & ! Shear on northeast corner of grid cells
+         deltat,                     & ! Delta at centre of grid cells
+         deltac,                     & ! Delta on corners
+         zs1, zs2,                   & ! Diagonal stress tensor components zs1 and zs2 
+         zs12                          ! Non-diagonal stress tensor component zs12
 
       REAL(wp) :: &
-         zresm            ,          & !: Maximal error on ice velocity
-         zindb            ,          & !: ice (1) or not (0)      
-         zdummy                        !: dummy argument
-
-      REAL(wp),DIMENSION(jpi,jpj) :: &
-         zu_ice           ,          & !: Ice velocity on previous time step
-         zv_ice           ,          &
-         zresr                         !: Local error on velocity
-
+         zresm            ,          & ! Maximal error on ice velocity
+         zindb            ,          & ! ice (1) or not (0)      
+         zdummy                        ! dummy argument
+
+      REAL(wp),DIMENSION(jpi,jpj) ::   zu_ice, zv_ice, zresr   ! Local error on velocity
+      !!-------------------------------------------------------------------
+#if  defined key_lim2 && ! defined key_lim2_vp
+# if defined key_agrif
+     USE ice_2, vt_s => hsnm
+     USE ice_2, vt_i => hicm
+# else
+     vt_s => hsnm
+     vt_i => hicm
+# endif
+     at_i(:,:) = 1. - frld(:,:)
+#endif
       !
       !------------------------------------------------------------------------------!
@@ -185,22 +173,23 @@
       !
       ! Put every vector to 0
-      zpresh(:,:) = 0.0 ; zc1(:,:) = 0.0
-      zpreshc(:,:) = 0.0
-      u_ice2(:,:)  = 0.0 ; v_ice1(:,:)  = 0.0
-      zdd(:,:)     = 0.0 ; zdt(:,:)     = 0.0 ; zds(:,:)     = 0.0
-
-      ! Ice strength on T-points
-      CALL lim_itd_me_icestrength(ridge_scheme_swi)
-
-      ! Ice mass and temp variables
-!CDIR NOVERRCHK
-      DO jj = k_j1 , k_jpj
+      zpresh (:,:) = 0._wp   ;   zc1   (:,:) = 0._wp
+      zpreshc(:,:) = 0._wp
+      u_ice2 (:,:) = 0._wp   ;   v_ice1(:,:) = 0._wp
+      zdd    (:,:) = 0._wp   ;   zdt   (:,:) = 0._wp   ;   zds(:,:) = 0._wp
+
+#if defined key_lim3
+      CALL lim_itd_me_icestrength( ridge_scheme_swi )      ! LIM-3: Ice strength on T-points
+#endif
+
+!CDIR NOVERRCHK
+      DO jj = k_j1 , k_jpj       ! Ice mass and temp variables
 !CDIR NOVERRCHK
          DO ji = 1 , jpi
             zc1(ji,jj)    = tms(ji,jj) * ( rhosn * vt_s(ji,jj) + rhoic * vt_i(ji,jj) )
-            zpresh(ji,jj) = tms(ji,jj) *  strength(ji,jj) / 2.
+#if defined key_lim3
+            zpresh(ji,jj) = tms(ji,jj) *  strength(ji,jj) * 0.5_wp
+#endif
             ! tmi = 1 where there is ice or on land
-            tmi(ji,jj)    = 1.0 - ( 1.0 - MAX( 0.0 , SIGN ( 1.0 , vt_i(ji,jj) - &
-               epsd ) ) ) * tms(ji,jj)
+            tmi(ji,jj)    = 1._wp - ( 1._wp - MAX( 0._wp , SIGN ( 1._wp , vt_i(ji,jj) - epsd ) ) ) * tms(ji,jj)
          END DO
       END DO
@@ -247,24 +236,20 @@
          DO ji = fs_2, fs_jpim1
 
-            zt11 = tms(ji,jj)*e1t(ji,jj)
-            zt12 = tms(ji+1,jj)*e1t(ji+1,jj)
-            zt21 = tms(ji,jj)*e2t(ji,jj)
-            zt22 = tms(ji,jj+1)*e2t(ji,jj+1)
+            zt11 = tms(ji  ,jj) * e1t(ji  ,jj)
+            zt12 = tms(ji+1,jj) * e1t(ji+1,jj)
+            zt21 = tms(ji,jj  ) * e2t(ji,jj  )
+            zt22 = tms(ji,jj+1) * e2t(ji,jj+1)
 
             ! Leads area.
-            zfrld1(ji,jj) = ( zt12 * ( 1.0 - at_i(ji,jj) ) + &
-               &                        zt11 * ( 1.0 - at_i(ji+1,jj) ) ) / ( zt11 + zt12 + epsd )
-            zfrld2(ji,jj) = ( zt22 * ( 1.0 - at_i(ji,jj) ) + &
-               &                        zt21 * ( 1.0 - at_i(ji,jj+1) ) ) / ( zt21 + zt22 + epsd )
+            zfrld1(ji,jj) = ( zt12 * ( 1.0 - at_i(ji,jj) ) + zt11 * ( 1.0 - at_i(ji+1,jj) ) ) / ( zt11 + zt12 + epsd )
+            zfrld2(ji,jj) = ( zt22 * ( 1.0 - at_i(ji,jj) ) + zt21 * ( 1.0 - at_i(ji,jj+1) ) ) / ( zt21 + zt22 + epsd )
 
             ! Mass, coriolis coeff. and currents
             zmass1(ji,jj) = ( zt12*zc1(ji,jj) + zt11*zc1(ji+1,jj) ) / (zt11+zt12+epsd)
             zmass2(ji,jj) = ( zt22*zc1(ji,jj) + zt21*zc1(ji,jj+1) ) / (zt21+zt22+epsd)
-            zcorl1(ji,jj) = zmass1(ji,jj) * ( e1t(ji+1,jj)*fcor(ji,jj) + &
-               e1t(ji,jj)*fcor(ji+1,jj) ) &
-               / (e1t(ji,jj) + e1t(ji+1,jj) + epsd )
-            zcorl2(ji,jj) = zmass2(ji,jj) * ( e2t(ji,jj+1)*fcor(ji,jj) + &
-               e2t(ji,jj)*fcor(ji,jj+1) ) &
-               / ( e2t(ji,jj+1) + e2t(ji,jj) + epsd )
+            zcorl1(ji,jj) = zmass1(ji,jj) * ( e1t(ji+1,jj)*fcor(ji,jj) + e1t(ji,jj)*fcor(ji+1,jj) )   &
+               &                          / ( e1t(ji,jj) + e1t(ji+1,jj) + epsd )
+            zcorl2(ji,jj) = zmass2(ji,jj) * ( e2t(ji,jj+1)*fcor(ji,jj) + e2t(ji,jj)*fcor(ji,jj+1) )   &
+               &                          / ( e2t(ji,jj+1) + e2t(ji,jj) + epsd )
             !
             u_oce1(ji,jj)  = u_oce(ji,jj)
@@ -290,6 +275,6 @@
             ! include it later
 
-            zdsshx =  (ssh_m(ji+1,jj) - ssh_m(ji,jj))/e1u(ji,jj)
-            zdsshy =  (ssh_m(ji,jj+1) - ssh_m(ji,jj))/e2v(ji,jj)
+            zdsshx =  ( ssh_m(ji+1,jj) - ssh_m(ji,jj) ) / e1u(ji,jj)
+            zdsshy =  ( ssh_m(ji,jj+1) - ssh_m(ji,jj) ) / e2v(ji,jj)
 
             za1ct(ji,jj) = ztagnx - zmass1(ji,jj) * grav * zdsshx
@@ -306,19 +291,19 @@
       ! Time step for subcycling
       dtevp  = rdt_ice / nevp
-      dtotel = dtevp / ( 2.0 * telast )
+      dtotel = dtevp / ( 2._wp * telast )
 
       !-ecc2: square of yield ellipse eccenticrity (reminder: must become a namelist parameter)
-      ecc2 = ecc*ecc
+      ecc2 = ecc * ecc
 
       !-Initialise stress tensor 
-      zs1(:,:)  = stress1_i(:,:) 
-      zs2(:,:)  = stress2_i(:,:)
+      zs1 (:,:) = stress1_i (:,:) 
+      zs2 (:,:) = stress2_i (:,:)
       zs12(:,:) = stress12_i(:,:)
 
-      !----------------------!
+      !                                               !----------------------!
       DO jter = 1 , nevp                              !    loop over jter    !
-         !----------------------!        
+         !                                            !----------------------!        
          DO jj = k_j1, k_jpj-1
-            zu_ice(:,jj) = u_ice(:,jj) ! velocity at previous time step
+            zu_ice(:,jj) = u_ice(:,jj)    ! velocity at previous time step
             zv_ice(:,jj) = v_ice(:,jj)
          END DO
@@ -385,6 +370,5 @@
             END DO
          END DO
-         CALL lbc_lnk( v_ice1(:,:), 'U', -1. )
-         CALL lbc_lnk( u_ice2(:,:), 'V', -1. )
+         CALL lbc_lnk( v_ice1, 'U', -1. )   ;   CALL lbc_lnk( u_ice2, 'V', -1. )      ! lateral boundary cond.
 
 !CDIR NOVERRCHK
@@ -394,15 +378,13 @@
 
                !- Calculate Delta at centre of grid cells
-               zdst       = (  e2u( ji  , jj   ) * v_ice1(ji,jj)            &
-                  &          - e2u( ji-1, jj   ) * v_ice1(ji-1,jj)          &
-                  &          + e1v( ji  , jj   ) * u_ice2(ji,jj)            &
-                  &          - e1v( ji  , jj-1 ) * u_ice2(ji,jj-1)          &
-                  &          )                                              &
+               zdst       = (  e2u(ji  , jj) * v_ice1(ji  ,jj)          &
+                  &          - e2u(ji-1, jj) * v_ice1(ji-1,jj)          &
+                  &          + e1v(ji, jj  ) * u_ice2(ji,jj  )          &
+                  &          - e1v(ji, jj-1) * u_ice2(ji,jj-1)          &
+                  &          )                                          &
                   &         / area(ji,jj)
 
-               delta = SQRT( zdd(ji,jj)*zdd(ji,jj) +                        & 
-                  &                       ( zdt(ji,jj)*zdt(ji,jj) + zdst*zdst ) * usecc2 )  
-               deltat(ji,jj) = MAX( SQRT(zdd(ji,jj)**2 +                    &
-                  (zdt(ji,jj)**2 + zdst**2)*usecc2), creepl )
+               delta = SQRT( zdd(ji,jj)*zdd(ji,jj) + ( zdt(ji,jj)*zdt(ji,jj) + zdst*zdst ) * usecc2 )  
+               deltat(ji,jj) = MAX( SQRT(zdd(ji,jj)**2 + (zdt(ji,jj)**2 + zdst**2)*usecc2), creepl )
 
                !-Calculate stress tensor components zs1 and zs2 
